% This program is written to take in a bunch of parameters and
% moments and spit out some derivatives to use in the computation
% of the standard errors.  This may be one heck of a mess!
function [derv_mean, derv_meand, derv_sq, derv_sqd, g, mom_sim, ...
          fm_succ, jbar, prof_in, intrat] = ...
    DerivFun(points, beta, delta, fc, sbar, trat_rd, srate, ...
             ginit, nFirms, nYears, sim_ind, moms, cv);

% Pick up the fixed parameter 
alph = 1/3;
mu = -0.3;

% Lets unpack the parameters
theta = points(1);
rho = points(2);
sig = points(3);
lambda = points(4);
a = points(5);
b = points(6);
gamma = points(7);
fc = points(8);
nu = alph*(1-theta)/(theta + alph*(1-theta));

% Call the value function
[g, q, qd, i, r, kr, z, kg, w, ec] = ValFun_Spill(theta, nu, mu, rho, sig, lambda, a, b, ...
                            beta, delta, gamma, fc, trat_rd, sbar, srate, ginit);

% Redo this with the extra inputs to get the valuation info.
[zp, kp, qp, ip, rp, dp, pip, pir, sp, yp, sgp, fsp, succ, countz] = ...
         SimPanel(g, q, i, r, kr, z, kg, w, nFirms, nYears, theta, nu, mu, rho, ...
                  sig, lambda, a, b, trat_rd, sbar, beta, delta, gamma, fc, srate);

% Now we take the trouble to put everything together and obtain a
% set of minimized moments.
% Here we can analyse the results by making a combined set of
% policy function matrices
zm = [zp(sim_ind:end,:)];
km = [kp(sim_ind:end,:)];
im = [ip(sim_ind:end,:)];
qm = [qp(sim_ind:end,:)];
rsm = [rp(sim_ind:end,:)./yp(sim_ind:end,:)];
pim = [pip(sim_ind:end,:)];
prm = [pir(sim_ind:end,:)];
dm = [dp(sim_ind:end,:)];
scm = [succ(sim_ind:end,:)];
sm = [sp(sim_ind:end,:)];
ym = [yp(sim_ind:end,:)];
sgm = [sgp(sim_ind:end,:)];
fsm = [fsp(sim_ind:end,:)];

% Do the moments for r&d
fm_rd = mean(vec(rsm));
std_rd = sqrt(mean(vec(rsm.^2)) - fm_rd^2);

% Here we want the auto-regressive term for r&d
beta_rd = regress(vec(rsm(2:end,:)), adc(vec(rsm(1:end-1,:))));
rho_rd = beta_rd(2);

% Pick up the sales to capital ratio
fm_fs = mean(vec(fsm));

% Do the moments for q
fm_q = mean(vec(qm));

% Do the moments for income after rd
fm_pr = mean(vec(prm));
std_pr = sqrt(mean(vec(prm.^2)) - fm_pr^2);

% Carry out the regression for income
prdiff = prm - fm_pr;
beta_inc = regress(vec(prdiff(2:end,:)), adc(vec(prdiff(1:end-1,:))));
rho_pr = beta_inc(2);

% Now we want investment
fm_i = mean(vec(im));  % We will exclude this for now
std_i = sqrt(mean(vec(im.^2)) - fm_i^2);
beta_inv = reg(vec(im(2:end,:)), adc(vec(im(1:end-1,:))));
rho_inv = beta_inv(2);

% Pick up some correlation matrices
co_rdinv = corr(rsm(:), im(:));
co_rdq = corr(rsm(:), qm(:));
co_rdk = mycorr(rsm(:), log(km(:)));
co_qi = corr(qm(:), im(:));
co_sglrd = corr(vec(sgm(2:end,:)), vec(rsm(1:end-1,:)));

% Pick up the success rate as well
fm_succ = mean(scm(:));

% Make an if statement here to check to see if we need these
% additional calculations. This is meant to save a bit of time
if cv == 1

        % Here we are going to do a quick calculation of intangible
  	% values. We'll get some surprisingly high numbers here.
        a_z = 1e10;  % This forces R&D to be zero.
	[g0, q0, qd0, i0, r0, kr0, z0, kg0, w0, ec0] = ValFun_Spill...
            (theta, nu, mu, rho, sig, lambda, a_z, b, ...
             beta, delta, gamma, fc, trat_rd, sbar, srate, ginit);
        
        % There is a bit of a mad adjustment to get the right firm value
        qs = q + beta*r*(1-gamma)*(1-trat_rd)./(1-delta+i);
        qdiff = (qs - q0);
        qdp = interp2(z0, kg0, qdiff, zp, kp);
        vdiff = qdp(sim_ind:end-1,:).*kp(sim_ind+1:end,:);
        vp = qp(sim_ind:end-1,:).*kp(sim_ind+1:end,:);
        intr = vdiff(:)./vp(:);
	intr_m = mean(intr);
	intr_pc = prctile(intr, [5 95]);      
        intrat = [intr_pc(1) intr_m intr_pc(2)];

	% Compute the mean success rate for this simulation
	sc_pr = (1 - exp(-a*sm.*(km.^(1-theta))));
	jbar_m = mean(vec(sc_pr));
	jbar_pc = prctile(sc_pr(:), [5 95]);
	jbar = [jbar_pc(1) jbar_m jbar_pc(2)];
                
	% Next we have to do the contribution to profits. This is a
        % bit different, though equally complicated.
	fkp = kp(sim_ind+1:end,:);
	kprat = (fkp.^theta)./kp(sim_ind:end-1,:);
	expt = exp(mu+sig^2/2)*(exp(lambda)-1);
	contp = a*expt*(1-sc_pr(1:end-1,:)).*(zp(sim_ind:end-1,:).^rho).*kprat;
	prof_pc = prctile(vec(contp), [5 95]);
	prof_m = mean(contp(:));
	prof_in = [prof_pc(1) prof_m prof_pc(2)];

	% Calculating the rate of return from a production function
	% approach is a bit tiresome here.
	fixcost = (median(kg).^theta)*median(z)*fc;
	profs = zp(sim_ind+1:end,:).*kp(sim_ind+1:end,:).^theta;
	kstock = kp(sim_ind+1:end,:);
	rstock = sp(sim_ind+1:end,:).*kp(sim_ind+1:end,:);
	indx = find(rstock > 0 & profs > 0);
    
        % Translate the values into logs
    	regp = log(profs(indx));
	regx = [log(kstock(indx)) log(rstock(indx))];
	rcoefs = regress(regp, adc(regx));
    
        % Compute the median values and obtain the rate of return
    	med_ys = median(profs(indx)./rstock(indx));
	rate_ret = med_ys*rcoefs(3);

end

% Put everything together into a big matrix
mom_sim = [fm_rd std_rd fm_fs fm_q fm_pr std_pr std_i ...
           rho_pr rho_rd rho_inv co_rdinv co_qi co_sglrd];

% Now lets organize the parameters
paras(1) = nFirms;

% Now we want the main data parameters
datac{1} = rsm;
datac{2} = qm;
datac{3} = prm;
datac{4} = im;
datac{5} = [rp(sim_ind-1:end-1,:)];
datac{6} = [pir(sim_ind-1:end-1,:)];
datac{7} = [ip(sim_ind-1:end-1,:)];
datac{8} = sgm;
datac{9} = fsm;

% Lets be brave and call the derivative function
[derv_mean, derv_sq] = DerivObj(datac, mom_sim, paras);
[derv_meand, derv_sqd] = DerivObj(datac, moms, paras);

return;
