% ------------------------------------------------------------ %
% PURPOSE:  This program is written primarily to test the code %
%	    for solving the value function and obtaining a set %
%	    of simulated data.  Some parts of this might feed  %
%	    up to another program which will tackle the issue  %
%	    of obtaining Simulated method of moments point     %
%	    estimates.					       %
% ------------------------------------------------------------ %

clear;
addpath ../Model/
addpath ../Quad/

% Initialize the variables of interest
readopt = 0;
if readopt == 1
    load xop;
    theta = xopt(1);
    rho = xopt(2);
    sigma = xopt(3);
    lambda = xopt(4);
    a = xopt(5);
    b = xopt(6);
    gamma = xopt(7);
    fc = xopt(8);
else
    theta = 0.4035; 
    % nu = 0.1;54;  
    rho = 0.6144;
    sigma = 0.3886;
    lambda = 0.2235;
    a = 5.2538;
    b = 0.5653;
    gamma = 0.2985;
    fc = 0.4108; 
end
mu = -0.30;
alph = 1/3;
nu = alph*(1-theta)/(theta + alph*(1-theta));
sbar = 0.833;

% Other parameters
delta = .165;
beta = 1/1.04;
trat_rd = 31.2/100;
srate = 0.025;

% Initialize v at zero to start things off
ginit = 0;

% Call the value function to solve for firm value
[g, q, qd, i, r, kr, z, kg, w] = ValFun_Spill(theta, nu, mu, rho, sigma, lambda, a, b, ...
                            beta, delta, gamma, fc, trat_rd, sbar, srate, ginit);
