function fmat = flipord(x, k);
% ---------------------------------------------------------- %
% Purpose: This program is written to flip a matrix in to    %
%          its identical values but inverting the order of   %
%          values along a given dimension.  This would be    %
%          useful for reordering tables.                     %
% ---------------------------------------------------------- %
% Written By: Missaka Warusawitharana
% Date: 02/12/06
% Last Update:
%
% ---------------------------------------------------------- %
% Notes:  This works only for column vectors
%
% ---------------------------------------------------------- %

% Find the size of the reordered dimension
siz = size(x, k);
sd = k - 1;

% Count dimensionality of matrix
n = ndims(x);

% Transform object to have switching dimension to 1
rx = shiftdim(x, k-1);

% Create an empty matrix containing the output 
res = zeros(size(rx));

% Do the reordering using a simple loop
for i = 1:siz
     res(i,:) = rx(siz-i+1,:); 
end

% Go back to the original shape of the matrix
fmat = shiftdim(res, n-k+1);

% End program
return;

