%%%  Function to compute the vectorization of any given matrix.
%%%  Helpful for Bayesian regression estimations, and simplifies code.
%%%  Written to simplify the many pains of reshape.

%% Written by: Missaka Warusawitharana
%% Last Updated: 6/30/04

function vc = vec(x)

siz = size(x);
elems = cumprod(siz); 
l = elems(end);

vc = reshape(x,l,1);

